//+------------------------------------------------------------------+
//|                                          Guppy MMA oscilator.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_level1  0
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int   Price                = PRICE_CLOSE;
extern int   SignalPeriod         = 13;
extern bool  ShowLines            = true;
extern bool  ShowLinesOnZeroCross = true;
extern color BullLineColor        = Green;
extern color BearLineColor        = Red;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double periods[]={3,5,8,10,12,15,30,35,40,45,50,60};
int    persize;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   persize =ArraySize(periods);
   return(0);
}
int deinit() { deleteLines(); return(0); }
void deleteLines()
{
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,8) == "GMMAline") ObjectDelete(objectName);
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double alpha = 2.0/(1.0+SignalPeriod);
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double sum  = 0;
      for(int j=0; j<persize; j++)
      {
         if (periods[j]<30)
               sum  += iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
         else  sum  -= iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
      }
      buffer1[i] = sum*10.0;
      buffer2[i] = buffer2[i+1]+alpha*(buffer1[i]-buffer2[i+1]);
      
      //
      //
      //
      //
      //
      
      if (ShowLines)
      {
         buffer3[i] = 0.00;
         if (ShowLinesOnZeroCross)
            {
               if (buffer1[i]>0) buffer3[i]= 1;
               if (buffer1[i]<0) buffer3[i]=-1;
            }
         else                     
            {
               if (buffer1[i]>buffer2[i]) buffer3[i]= 1;
               if (buffer1[i]<buffer2[i]) buffer3[i]=-1;
            }
      }            
   }
   
   //
   //
   //
   //
   //
   
   if (ShowLines)
   {
      deleteLines();
      for (i=WindowBarsPerChart(); i>=0; i--)
      {
         if (buffer3[i] != buffer3[i+1])
         {
            if (buffer3[i]==1)
               color  theColor = BullLineColor;
            else      theColor = BearLineColor;
            string name = "GMMAline"+Time[i];

            //
            //
            //
            //
            //
            
            ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
               ObjectSet(name,OBJPROP_COLOR,theColor);
               ObjectSet(name,OBJPROP_BACK ,true);
         }         
      }
   }
   return(0);
}